execute if entity @s[tag=!cu-if-block] unless block ~ ~1 ~ #boiler:itemframe-allow-block positioned ~ ~0.53125 ~ run function boiler:marker/block-itemframe
execute if entity @s[tag=cu-if-block] if block ~ ~1 ~ #boiler:itemframe-allow-block positioned ~ ~0.53125 ~ run function boiler:marker/allow-itemframe

execute if entity @s[tag=!cu-water] if block ~ ~ ~ water_cauldron run function boiler:marker/be-water
execute if entity @s[tag=!cu-dry] if block ~ ~ ~ cauldron run function boiler:marker/be-dry
execute if entity @s[tag=!cu-lava] if block ~ ~ ~ lava_cauldron run function boiler:marker/be-lava
execute if entity @s[tag=!cu-snow] if block ~ ~ ~ powder_snow_cauldron run function boiler:marker/be-snowy

execute if entity @s[tag=cu-water] as @e[type=#boiler:water_damage,distance=0.001..0.5] run effect give @s wither 1 1 true
execute if entity @s[tag=cu-snow] as @e[type=blaze,distance=0.001..0.5] run effect give @s wither 1 1 true

execute if block ~ ~-1 ~ #boiler:hot if entity @s[tag=cu-water-snow] if score @s cu-temperature < *max-temperature cu-const run function boiler:marker/temperature/add
execute if block ~ ~-2 ~ #boiler:very-hot if entity @s[tag=cu-water-snow] run function boiler:marker/temperature/add

execute if block ~ ~-1 ~ #boiler:cool if entity @s[tag=cu-water] if score @s cu-temperature < *max-temperature cu-const run function boiler:marker/temperature/sub

execute unless block ~ ~-1 ~ #boiler:cool if entity @s[tag=cu-water] if score @s cu-temperature matches ..1139 run function boiler:marker/temperature/slow_add

execute if score @s cu-temperature matches 1141.. unless block ~ ~-1 ~ #boiler:hot unless block ~ ~-2 ~ #boiler:very-hot run function boiler:marker/temperature/sub

execute if entity @s[scores={cu-temperature=4800..,cu-evaporation=..799}] run scoreboard players add @s cu-evaporation 1
execute if score @s cu-evaporation matches 800.. run function boiler:marker/evaporation/1

execute if score @s cu-temperature >= @s cu-splash-temperature run function boiler:marker/temperature/splash
execute if score @s cu-temperature >= @s cu-boil-temperature if entity @s[tag=!cu-boil] run tag @s add cu-boil
execute if entity @s[tag=cu-boil] unless score @s cu-temperature >= @s cu-boil-temperature run tag @s remove cu-boil

execute if entity @s[tag=cu-soup] run function boiler:marker/be-soup


scoreboard players operation *sign-c-temp cu-task = @s cu-temperature
scoreboard players operation *sign-c-temp cu-task /= *60 cu-const
scoreboard players operation *sign-c-temp cu-task *= *926 cu-const
scoreboard players operation *sign-c-temp cu-task /= *1000 cu-const

scoreboard players operation *sign-f-temp cu-task = *sign-c-temp cu-task
scoreboard players operation *sign-f-temp cu-task *= *18 cu-const
scoreboard players operation *sign-f-temp cu-task /= *10 cu-const
scoreboard players operation *sign-f-temp cu-task += *32 cu-const

execute if score *sign-c-temp cu-task matches 80.. as @e[distance=0.01..0.4,predicate=!boiler:fire_resistance,type=!#boiler:fire_immune] run effect give @s wither 1 1 true

execute if block ~-1 ~ ~ #signs[facing=west] run data merge block ~-1 ~ ~ {Text2:'[{"score":{"name":"*sign-c-temp","objective":"cu-task"}},{"text":"°C "},{"score":{"name":"*sign-f-temp","objective":"cu-task"}},{"text":"°F"}]'}
execute if block ~1 ~ ~ #signs[facing=east] run data merge block ~1 ~ ~ {Text2:'[{"score":{"name":"*sign-c-temp","objective":"cu-task"}},{"text":"°C "},{"score":{"name":"*sign-f-temp","objective":"cu-task"}},{"text":"°F"}]'}
execute if block ~ ~ ~-1 #signs[facing=north] run data merge block ~ ~ ~-1 {Text2:'[{"score":{"name":"*sign-c-temp","objective":"cu-task"}},{"text":"°C "},{"score":{"name":"*sign-f-temp","objective":"cu-task"}},{"text":"°F"}]'}
execute if block ~ ~ ~1 #signs[facing=south] run data merge block ~ ~ ~1 {Text2:'[{"score":{"name":"*sign-c-temp","objective":"cu-task"}},{"text":"°C "},{"score":{"name":"*sign-f-temp","objective":"cu-task"}},{"text":"°F"}]'}